Ticket #36276

luaotfload v2.7 でエラー?

Open Date: 2016-04-23 16:01 Last Update: 2016-04-29 18:07

Reporter:
Owner:
(None)
Type:
Status:
Closed
Component:
(None)
MileStone:
(None)
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
None
File:
1

Details

既知かもしれませんが、luaotfload 2016/04/21 v2.7 と LuaTeX-ja 20160421.0 を併用すると

\documentclass{ltjsarticle}
\begin{document}
テストです。
\end{document}
がエラーになりました。
luaotfload | resolve : step 1: apply method "tex" (function: 0x7fe1ac466cc0)
luaotfload | resolve : 1: method "tex" indicated lookup success
luaotfload | resolve : method "tex" resolved "cmr10" -> cmr10 (cmr10.tfm).../texmf-dist/tex/luat
ex/lualibs/lualibs-basic-merged.lua:2578: bad argument 
#1 to 'open' (string expected, got nil).
<to be read again> 
relax 
l.44 \kanjiencoding{JY3}\selectfont
                                 \adjustbaseline
? 
LuaTeX-ja の問題なのかどうかわからないのですが、報告しておきます。

Ticket History (3/18 Histories)

2016-04-23 16:01 Updated by: aminophen
  • New Ticket "luaotfload v2.7 でエラー?" created
2016-04-23 18:11 Updated by: h7k
Comment

昨日角藤さんからメールが来て,私も今朝確認しました……が,まだよくわかりません.

2016-04-23 18:32 Updated by: kmaeda
Comment

たぶん ltj-rmlbgm.lua の366行目で落ちていると思います. エラーに出ている通り lltjcore.sty の33行目で cmtt9 をロードしますが,これが luatexja で定義したフォントロードの方法と不整合を起こしているようです.

2016-04-23 18:34 Updated by: kmaeda
Comment

よく見たら aminophen さんのは cmr10 で落ちていましたか. 私は以下で試しています:

  1. \documentclass{article}
  2. \usepackage{fontspec}
  3. \usepackage{luatexja}
  4. \begin{document}
  5. \end{document}

ログ:

(/home/kmaeda/texmf/tex/luatex/luatexja/src/patches/lltjcore.sty
luaotfload | resolve : step 1: apply method "tex" (function: 0x32f0500)
luaotfload | resolve : 1: method "tex" indicated lookup success
luaotfload | resolve : method "tex" resolved "cmtt9" -> cmtt9 (cmtt9.tfm)...6/texmf-dist
/tex/luatex/lualibs/lualibs-basic-merged.lua:2578: bad argument #1 to 'open' (s
tring expected, got nil).
<to be read again> 
\global 
l.34 \newtoks\@bannertoken

2016-04-23 19:18 Updated by: kmaeda
Comment

色々試していたのですが,よくわからないと書かれている理由がわかりました. ltj-jfont.lua の381行目の

   otfl_fdr= luatexbase.remove_from_callback('define_font', 'luaotfload.define_font')
が問題ないはずなのに,なぜか実際に使おうとするとエラーになるのですね.なんなんだろう…….

2016-04-23 20:14 Updated by: aminophen
Comment

関係ないかもしれませんが、LuaTeX-ja とも luaotfload とも関係なく

  1. \documentclass{article}
  2. \usepackage{fontspec}
  3. \setmainfont{cmtt10}
  4. \begin{document}
  5. Hello, \LaTeX!
  6. \end{document}
が LuaTeX beta-0.95.0 ではエラーになります。
luaotfload | resolve : step 1: apply method "tex" (function: 0x7fa3e561b920)
luaotfload | resolve : 1: method "tex" indicated lookup success
luaotfload | resolve : method "tex" resolved "cmtt10" -> cmtt10 (cmtt10.tfm)
luaotfload | resolve : step 1: apply method "tex" (function: 0x7fa3e561b920)
luaotfload | resolve : 1: method "tex" indicated lookup success
luaotfload | resolve : method "tex" resolved "cmtt10" -> cmtt10 (cmtt10.tfm)...exmf-dist/tex/luat
ex/luaotfload/luaotfload-auxiliary.lua:333: attempt to index field 'metadata' (a nil value)
stack traceback:
	...exmf-dist/tex/luatex/luaotfload/luaotfload-auxiliary.lua:333: in function '
provides_script'
	/usr/local/texlive/2016/texmf-dist/tex/latex/fontspec/fontspec.lua:32: in func
tion 'check_ot_script'
	[\directlua]:1: in main chunk.
\fontspec_check_script:nTF ...ontspec_font","#1")}
                                                  \bool_if:NTF \l__fontspec_...

l.3 \setmainfont{cmtt10}
しかし LuaTeX beta-0.80.0 では正常に通ります。

2016-04-23 20:31 Updated by: aminophen
Comment

luaotfload の問題かもしれないので、向こうの Issue にも出してみました

2016-04-23 20:42 Updated by: h7k
Comment

LuaTeX-ja 側で独自キャッシュを作るときに発生しているエラーのようです. commit c3e2159 で ltj-jfont.lua に修正を加えてみましたが,そちらの環境ではどうでしょうか.

2016-04-23 21:32 Updated by: kmaeda
Comment

ありがとうございます.commit c3e2159 ではエラーなく通るようになりました.

2016-04-23 21:38 Updated by: aminophen
Comment

私のところでも commit c3e2159 が通ることを確認しました。ありがとうございます。(\setmainfont とかが通らないのはどうやら fontspec が新しい fontloader に未対応のため、のようです。)

2016-04-24 11:12 Updated by: h7k
Comment

関係ないかもしれませんが,fontloader 関連だと思うのでここにぶら下げておきます.

\documentclass{ltjsarticle}
\begin{document}
\vrule\hbox{(あ)}\vrule
\end{document}
をluaotfload v2.7 でタイプセットすると,添付した list_bdd_paren.pdf のように 括弧類がずれます.

2016-04-24 11:22 Updated by: kmaeda
Comment

添付した list_bdd_paren.pdf のように 括弧類がずれます.

再現しないと思ったのですが,tlmgr でアップデートしたら再現しました.luatex のバイナリ更新のせいでしょうか.

2016-04-24 11:47 Updated by: aminophen
Comment

Win32 ですが、luatex.dll 以外が 2016/04/18 22:23 だと正常ですが、2016/04/22 07:48 のものに置き換えると再現しました。他のファイルには触れていません。したがって、この間の luatex のバイナリ更新を調べればなにかわかるでしょうか。

2016-04-24 11:48 Updated by: aminophen
Comment

typo です:s/luatex.dll 以外が/luatex.dll が/g

2016-04-24 12:30 Updated by: h7k
Comment

添付した list_bdd_paren.pdf のように 括弧類がずれます.

luatex r5953 では直っているようです(r5947 で入ったバグ?).

2016-04-28 21:12 Updated by: kmaeda
Comment

luatex r5953 では直っているようです(r5947 で入ったバグ?).

確かに tlmgr update すると直ったようです.

2016-04-29 18:07 Updated by: h7k
  • Ticket Close date is changed to 2016-04-29 18:07
  • Status Update from Open to Closed
Comment

luaotfload が更新されたのに合わせ,20160429.0 を出しました.

Attachment File List

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login